diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index bc0841b..d9d6bd9 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -3836,3 +4111,612 @@ reparameterize_pathlist_by_child(PlannerInfo *root,
 
 	return result;
 }
+
+/*
+ * Add (non-Var) grouping expressions contained in group_exprs target to a
+ * subpath. The passed in subpath should not be touched so that it can still
+ * be used as a subpath for non-grouped paths. Therefore we wrap it into
+ * ResultPath, to which we actually add those expressions.
+ */
+static Path *
+add_grouping_expressions_to_subpath(PlannerInfo *root, Path *subpath,
+									PathTarget *group_exprs)
+{
+	PathTarget *target;
+	ListCell   *lc;
+	int			i;
+
+	/*
+	 * The subpath must stay intact because, besides producing input data for
+	 * aggregation, it can participate in a plan that does not use aggregation
+	 * push-down. For the same reason we pass force_result=true to
+	 * create_projection_path below.
+	 */
+	target = copy_pathtarget(subpath->pathtarget);
+
+	Assert(group_exprs->sortgrouprefs != NULL);
+	i = 0;
+	foreach(lc, group_exprs->exprs)
+	{
+		Index		sortgroupref;
+		GroupedVar *gvar;
+
+		sortgroupref = group_exprs->sortgrouprefs[i++];
+		gvar = lfirst_node(GroupedVar, lc);
+		add_column_to_pathtarget(target, (Expr *) gvar, sortgroupref);
+	}
+
+	return (Path *) create_projection_path(root,
+										   subpath->parent,
+										   subpath,
+										   target,
+										   true);
+}
+
+/*
+ * Find out if path produces an unique set of expressions and set uniquekeys
+ * accordingly.
+ *
+ * TODO Check if any expression of any unique key isn't nullable, whether in
+ * the table / index or by an outer join.
+ */
+void
+make_uniquekeys(PlannerInfo *root, Path *path)
+{
+	RelOptInfo *rel;
+
+	/*
+	 * The unique keys are not interesting if there's no chance to push
+	 * aggregation down to base relations / joins.
+	 */
+	if (root->grouped_var_list == NIL)
+		return;
+
+	/*
+	 * Do not accept repeated calls of the function on the same path.
+	 */
+	if (path->uniquekeys != NIL)
+		return;
+
+	rel = path->parent;
+
+	/*
+	 * Base relations.
+	 */
+	if (IsA(path, IndexPath) ||
+		(IsA(path, Path) &&path->pathtype == T_SeqScan) ||
+		IsA(path, AppendPath) ||IsA(path, MergeAppendPath))
+	{
+		ListCell   *lc;
+
+		/*
+		 * Derive grouping keys from unique indexes.
+		 */
+		if (IsA(path, IndexPath) ||IsA(path, Path))
+		{
+			foreach(lc, rel->indexlist)
+			{
+				IndexOptInfo *index = lfirst_node(IndexOptInfo, lc);
+
+				make_uniquekeys_for_unique_index(rel->reltarget, index, path);
+			}
+		}
+		else if (IsA(path, AppendPath) ||IsA(path, MergeAppendPath))
+			make_uniquekeys_for_append_path(root, path);
+#ifdef USE_ASSERT_CHECKING
+		else
+			Assert(false);
+#endif
+		return;
+	}
+
+	if (IsA(path, AggPath))
+	{
+		/*
+		 * The immediate output of aggregation essentially produces an unique
+		 * set of grouping keys.
+		 */
+		make_uniquekeys_for_agg_path(path);
+	}
+	else if (IS_JOIN_REL(path->parent))
+	{
+		JoinPath   *jpath = (JoinPath *) path;
+		Path	   *outerpath = jpath->outerjoinpath;
+		Path	   *innerpath = jpath->innerjoinpath;
+		ListCell   *l1;
+
+		/*
+		 * Find out if the join produces unique keys for various combinations
+		 * of input sets of unique keys.
+		 *
+		 * TODO Implement heuristic that picks a few most useful sets on each
+		 * side, to avoid exponential growth of the uniquekeys list as we
+		 * proceed from lower to higher joins. Maybe also discard the
+		 * resulting sets containing unique expressions which are not grouping
+		 * expressions (and of course which are not aggregates) of this join's
+		 * target.
+		 */
+		foreach(l1, outerpath->uniquekeys)
+		{
+			Bitmapset  *outerset = (Bitmapset *) lfirst(l1);
+			ListCell   *l2;
+
+			foreach(l2, innerpath->uniquekeys)
+			{
+				Bitmapset  *innerset = (Bitmapset *) lfirst(l2);
+				Bitmapset  *joinset;
+
+				/*
+				 * Given that unique keys of each input relation are contained
+				 * in that relation's target, the union of the key sets should
+				 * be contained in the join target.
+				 */
+				joinset = bms_union(outerset, innerset);
+
+				/* Add the set to the path. */
+				add_uniquekeys_to_path((Path *) jpath, joinset);
+			}
+		}
+	}
+#ifdef USE_ASSERT_CHECKING
+
+	/*
+	 * TODO Consider other ones, e.g. UniquePath.
+	 */
+	else
+		Assert(false);
+#endif
+}
+
+/*
+ * Create a set of positions of expressions in reltarget if the index is
+ * unique and if reltarget contains all the index columns. Add the set to
+ * uniquekeys if identical one is not already there.
+ */
+static void
+make_uniquekeys_for_unique_index(PathTarget *reltarget, IndexOptInfo *index,
+								 Path *path)
+{
+	int			i;
+	Bitmapset  *new_set = NULL;
+
+	/*
+	 * Give up if the index does not guarantee uniqueness.
+	 */
+	if (!index->unique || !index->immediate ||
+		(index->indpred != NIL && !index->predOK))
+		return;
+
+	/*
+	 * For the index path to be acceptable, reltarget must contain all the
+	 * index columns.
+	 *
+	 * reltarget is not supposed to contain non-var expressions, so the index
+	 * should neither.
+	 */
+	if (index->indexprs != NULL)
+		return;
+
+	for (i = 0; i < index->ncolumns; i++)
+	{
+		int			indkey = index->indexkeys[i];
+		ListCell   *lc;
+		bool		found = false;
+		int			j = 0;
+
+		foreach(lc, reltarget->exprs)
+		{
+			Var		   *var = lfirst_node(Var, lc);
+
+			if (var->varno == index->rel->relid && var->varattno == indkey)
+			{
+				new_set = bms_add_member(new_set, j);
+				found = true;
+				break;
+			}
+
+			j++;
+		}
+
+		/*
+		 * If rel needs less than the whole index key then the values of the
+		 * columns matched so far can be duplicate.
+		 */
+		if (!found)
+		{
+			bms_free(new_set);
+			return;
+		}
+	}
+
+	/*
+	 * Add the set to the path, unless it's already there.
+	 */
+	add_uniquekeys_to_path(path, new_set);
+}
+
+/*
+ * Create uniquekeys for a path that has Aggrefs in its target.
+ * set.
+ *
+ * Besides AggPath, ForeignPath is a known use case for this function.
+ */
+void
+make_uniquekeys_for_agg_path(Path *path)
+{
+	PathTarget *target;
+	ListCell   *lc;
+	Bitmapset  *keyset = NULL;
+	int			i = 0;
+
+	target = path->pathtarget;
+	Assert(target->sortgrouprefs != NULL);
+
+	foreach(lc, target->exprs)
+	{
+		Expr	   *expr = (Expr *) lfirst(lc);
+
+		if (IsA(expr, GroupedVar))
+		{
+			GroupedVar *gvar = castNode(GroupedVar, expr);
+
+			if (!IsA(gvar->gvexpr, Aggref))
+			{
+				/*
+				 * Generic grouping expression.
+				 */
+				keyset = bms_add_member(keyset, i);
+			}
+		}
+		else
+		{
+			Assert(IsA(expr, Var));
+
+			if (target->sortgrouprefs[i] > 0)
+			{
+				/*
+				 * Plain Var grouping expression.
+				 */
+				keyset = bms_add_member(keyset, i);
+			}
+			else
+			{
+				/*
+				 * A column functionally dependent on the GROUP BY clause?
+				 */
+			}
+		}
+
+		i++;
+	}
+
+	add_uniquekeys_to_path((Path *) path, keyset);
+}
+
+/*
+ * Create uniquekeys for a AppendPath or MergeAppendPath.
+ *
+ * Besides AggPath, ForeignPath is a known use case for this function.
+ */
+static void
+make_uniquekeys_for_append_path(PlannerInfo *root, Path *path)
+{
+	RelOptInfo *rel = path->parent;
+	List	   *subpaths;
+	Path	   *subpath;
+	ListCell   *l1;
+	bool		first = true;
+	List	   *uniquekeys_common = NIL;
+
+	/*
+	 * In addition to the requirement that all subpaths must have uniquekeys
+	 * set, the table needs to be partitioned in a specific way. Reject
+	 * non-partitioned tables immediately, the other check to follow.
+	 */
+	if (!IS_PARTITIONED_REL(rel))
+		return;
+
+	if (IsA(path, AppendPath))
+		subpaths = ((AppendPath *) path)->subpaths;
+	else if (IsA(path, MergeAppendPath))
+		subpaths = ((MergeAppendPath *) path)->subpaths;
+#ifdef USE_ASSERT_CHECKING
+	else
+		Assert(false);
+#endif
+
+	/*
+	 * Check if each subpath has uniquekeys.
+	 */
+	foreach(l1, subpaths)
+	{
+		subpath = (Path *) lfirst(l1);
+
+		/*
+		 * If any subpath does not have uniquekeys, the whole append path can
+		 * have them neither.
+		 */
+		if (subpath->uniquekeys == NIL)
+			return;
+	}
+
+	/*
+	 * Choose groupkey sets that each subpath has.
+	 */
+	foreach(l1, subpaths)
+	{
+		List	   *common_new = NIL;
+		ListCell   *l2;
+
+		subpath = (Path *) lfirst(l1);
+
+		if (uniquekeys_common == NIL)
+		{
+			/* Get the initial list from the first subpath. */
+			uniquekeys_common = subpath->uniquekeys;
+			continue;
+		}
+
+		/*
+		 * Remove items missing in the current subpath from uniquekeys_common.
+		 */
+		foreach(l2, uniquekeys_common)
+		{
+			Bitmapset  *set1 = (Bitmapset *) lfirst(l2);
+			ListCell   *l3;
+
+			/*
+			 * Does the current subpath contain this set?
+			 */
+			foreach(l3, subpath->uniquekeys)
+			{
+				Bitmapset  *set2 = (Bitmapset *) lfirst(l3);
+
+				if (bms_equal(set1, set2))
+				{
+					common_new = lappend(common_new, set1);
+					break;
+				}
+			}
+		}
+
+		/*
+		 * If there are no sets in common, the next subpaths cannot help us.
+		 */
+		if (common_new == NIL)
+			return;
+
+		/*
+		 * Adopt the new, possibly reduced list.
+		 */
+		uniquekeys_common = common_new;
+	}
+
+	foreach(l1, subpaths)
+	{
+		subpath = (Path *) lfirst(l1);
+
+		/*
+		 * The following tests should ideally be performed either on
+		 * rel->reltarget or rel->gpi->target outside the iteration of
+		 * subpaths. However there's no easy way to find out if path is
+		 * grouped or not. So we check the target of the first subpath and
+		 * assume that the other ones would pass or fail in the same way:
+		 * another subpath target should be the same path target whose
+		 * attributes are translated to another child relations.
+		 */
+		if (first)
+		{
+			List	   *partexprs = NIL;
+			List	   *partexprs_all = NIL;
+			ListCell   *l2,
+					   *l3;
+			AppendRelInfo **appinfos;
+			int			i,
+						nappinfos;
+			bool		found;
+			List	   *texprs = NIL;
+
+			/*
+			 * Put all partition expressions into two lists --- one for
+			 * non-nullable expressions, one for nullable.
+			 */
+			for (i = 0; i < rel->part_scheme->partnatts; i++)
+			{
+				List	   *sublist;
+
+				sublist = rel->partexprs[i];
+				if (sublist != NIL)
+				{
+					partexprs = list_union(partexprs, sublist);
+					partexprs_all = list_union(partexprs_all,
+											   sublist);
+				}
+
+				/*
+				 * The nullable expressions should only appear in
+				 * partexprs_all.
+				 */
+				sublist = rel->nullable_partexprs[i];
+				if (sublist != NIL)
+					partexprs_all = list_union(partexprs_all,
+											   sublist);
+			}
+			Assert(partexprs != NIL);
+
+			/*
+			 * Translate the partitioning expressions so that they can match
+			 * the subpath target.
+			 */
+			appinfos =
+				find_appinfos_by_relids(root, subpath->parent->relids,
+										&nappinfos);
+			partexprs = (List *)
+				adjust_appendrel_attrs(root, (Node *) partexprs,
+									   nappinfos, appinfos);
+			partexprs_all = (List *)
+				adjust_appendrel_attrs(root, (Node *) partexprs_all,
+									   nappinfos, appinfos);
+			pfree(appinfos);
+
+			/*
+			 * Since equivalence classes can be used to derive target
+			 * expressions, the following checks have to consider ECs too. The
+			 * targetlist we construct here contains the original expressions
+			 * plus those generated from the appropriate ECs.
+			 */
+			foreach(l2, subpath->pathtarget->exprs)
+			{
+				Expr	   *texpr = (Expr *) lfirst(l2);
+
+				if (IsA(texpr, GroupedVar))
+				{
+					GroupedVar *gvar = castNode(GroupedVar, texpr);
+
+					if (IsA(gvar->gvexpr, Aggref))
+					{
+						/*
+						 * Aggregate should not appear in any EC.
+						 */
+						texprs = lappend(texprs, texpr);
+						continue;
+					}
+
+					/*
+					 * The contained expression (i.e. generic grouping
+					 * expression) is what we'll search for in the ECs.
+					 */
+					texpr = gvar->gvexpr;
+				}
+
+				/*
+				 * Search for matching EC.
+				 */
+				foreach(l3, root->group_pathkeys)
+				{
+					PathKey    *pk = lfirst_node(PathKey, l3);
+					EquivalenceClass *ec = pk->pk_eclass;
+					ListCell   *l4;
+					EquivalenceMember *em;
+
+					if (ec->ec_below_outer_join)
+						continue;
+
+					if (ec->ec_has_volatile)
+						continue;
+
+					foreach(l4, ec->ec_members)
+					{
+						em = lfirst_node(EquivalenceMember, l4);
+
+						if (em->em_nullable_relids)
+							continue;
+
+						if (!bms_is_subset(em->em_relids,
+										   subpath->parent->relids))
+							continue;
+
+						if (equal(em->em_expr, texpr))
+							break;
+					}
+
+					/*
+					 * texpr not found in the current EC, try the next one.
+					 */
+					if (l4 == NULL)
+						continue;
+
+					/*
+					 * The EC does match, so add all its members to texprs.
+					 */
+					foreach(l4, ec->ec_members)
+					{
+						em = lfirst_node(EquivalenceMember, l4);
+						texprs = lappend(texprs, em->em_expr);
+					}
+
+					/*
+					 * No expression is supposed to appear in multiple EC.
+					 */
+					continue;
+				}
+			}
+
+			/*
+			 * To ensure that no output row can be produced by multiple
+			 * partitions, check that:
+			 *
+			 * (a) at least one output column is a partitioning expression.
+			 * Thus no output row of this path can appear in multiple
+			 * partitions.
+			 *
+			 * Only search in the non-nullable partitioning expressions
+			 * because NULL value can be generated by any partition.
+			 */
+			found = false;
+			foreach(l2, texprs)
+			{
+				Expr	   *texpr = (Expr *) lfirst(l2);
+
+				/*
+				 * Try to find the matching partitioning expression.
+				 */
+				foreach(l3, partexprs)
+				{
+					Expr	   *pexpr = lfirst(l3);
+
+					if (equal(texpr, pexpr))
+					{
+						found = true;
+						break;
+					}
+				}
+
+				if (found)
+					break;
+			}
+			if (!found)
+			{
+				list_free(uniquekeys_common);
+				return;
+			}
+
+			/*
+			 * (b) there's no partitioning expression not contained in the
+			 * target. If there was some, then the partitioning expression
+			 * found above could appear in multiple partitions.
+			 *
+			 * Even nullable partition key makes harm here, so consider all
+			 * partition keys this time.
+			 */
+			foreach(l2, partexprs_all)
+			{
+				Expr	   *pexpr = lfirst(l2);
+
+				found = false;
+				foreach(l3, texprs)
+				{
+					Expr	   *texpr = (Expr *) lfirst(l3);
+
+					if (equal(pexpr, texpr))
+					{
+						found = true;
+						break;
+					}
+				}
+				if (!found)
+				{
+					list_free(uniquekeys_common);
+					return;
+				}
+			}
+			list_free(texprs);
+
+			/* Do not repeat the checks for the other subpaths. */
+			first = false;
+		}
+	}
+
+	/* All the checks passed. */
+	path->uniquekeys = uniquekeys_common;
+}
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index f743871..f763a97 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1466,6 +1466,51 @@ relation_excluded_by_constraints(PlannerInfo *root,
 	return false;
 }
 
+/*
+ * Remove from restrictions list items implied by table constraints
+ */
+void remove_restrictions_implied_by_constraints(PlannerInfo *root,
+												RelOptInfo *rel, RangeTblEntry *rte)
+{
+	List	   *constraint_pred;
+	List	   *safe_constraints = NIL;
+	List	   *safe_restrictions = NIL;
+	ListCell   *lc;
+
+	if (rte->rtekind != RTE_RELATION || rte->inh)
+		return;
+
+	/*
+	 * OK to fetch the constraint expressions.  Include "col IS NOT NULL"
+	 * expressions for attnotnull columns, in case we can refute those.
+	 */
+	constraint_pred = get_relation_constraints(root, rte->relid, rel, true);
+
+	/*
+	 * We do not currently enforce that CHECK constraints contain only
+	 * immutable functions, so it's necessary to check here. We daren't draw
+	 * conclusions from plan-time evaluation of non-immutable functions. Since
+	 * they're ANDed, we can just ignore any mutable constraints in the list,
+	 * and reason about the rest.
+	 */
+	foreach(lc, constraint_pred)
+	{
+		Node	   *pred = (Node*) lfirst(lc);
+
+		if (!contain_mutable_functions(pred))
+			safe_constraints = lappend(safe_constraints, pred);
+	}
+
+	foreach(lc, rel->baserestrictinfo)
+	{
+		RestrictInfo *rinfo = lfirst_node(RestrictInfo, lc);
+		if (!predicate_implied_by(list_make1(rinfo->clause), safe_constraints, false)) {
+			safe_restrictions = lappend(safe_restrictions, rinfo);
+		}
+	}
+	rel->baserestrictinfo = safe_restrictions;
+}
+
 
 /*
  * build_physical_tlist
diff --git a/src/backend/optimizer/util/predtest.c b/src/backend/optimizer/util/predtest.c
index 134460c..47cd4c9 100644
--- a/src/backend/optimizer/util/predtest.c
+++ b/src/backend/optimizer/util/predtest.c
@@ -17,6 +17,7 @@
 
 #include "catalog/pg_proc.h"
 #include "catalog/pg_type.h"
+#include "catalog/pg_operator.h"
 #include "executor/executor.h"
 #include "miscadmin.h"
 #include "nodes/nodeFuncs.h"
@@ -1407,6 +1408,13 @@ static const StrategyNumber BT_refute_table[6][6] = {
 	{none, none, BTEQ, none, none, none}	/* NE */
 };
 
+#define Int2LessOperator 95
+#define Int2LessOrEqualOperator 522
+#define Int4LessOrEqualOperator 523
+#define Int8LessOrEqualOperator 414
+#define DateLessOrEqualOperator 1096
+#define DateLessOperator 1095
+
 
 /*
  * operator_predicate_proof
@@ -1600,6 +1608,17 @@ operator_predicate_proof(Expr *predicate, Node *clause, bool refute_it)
 	if (clause_const->constisnull)
 		return false;
 
+	if (!refute_it
+		&& ((pred_op == Int4LessOrEqualOperator && clause_op == Int4LessOperator)
+			|| (pred_op == Int8LessOrEqualOperator && clause_op == Int8LessOperator)
+			|| (pred_op == Int2LessOrEqualOperator && clause_op == Int2LessOperator)
+			|| (pred_op == DateLessOrEqualOperator && clause_op == DateLessOperator))
+		&& pred_const->constbyval && clause_const->constbyval
+		&& pred_const->constvalue + 1 == clause_const->constvalue)
+	{
+		return true;
+	}
+
 	/*
 	 * Lookup the constant-comparison operator using the system catalogs and
 	 * the operator implication tables.
